unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, FPUnit;

type
  TMainForm = class(TForm)
    BitBtn1: TBitBtn;
    GroupBox2: TGroupBox;
    ckIgnore: TCheckBox;
    Bevel1: TBevel;
    ControlWPanel: TPanel;
    Edit1: TEdit;
    Test1: TBitBtn;
    Edit2: TEdit;
    Test2: TBitBtn;
    Test3: TBitBtn;
    Edit3: TEdit;
    Test4: TBitBtn;
    Edit4: TEdit;
    Test5: TBitBtn;
    Edit5: TEdit;
    CWPanel: TPanel;
    ckOperand: TCheckBox;
    ckOverflow: TCheckBox;
    ckByZero: TCheckBox;
    ckUnderflow: TCheckBox;
    ckInexact: TCheckBox;
    FloatingPointUnit1: TFloatingPointUnit;
    FloatingPointUnit2: TFloatingPointUnit;
    Panel1: TPanel;
    Label1: TLabel;
    BugPresentLabel: TLabel;
    Label2: TLabel;
    FPUPresentLabel: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ckIgnoreClick(Sender: TObject);
    procedure Test1Click(Sender: TObject);
    procedure ckByZeroClick(Sender: TObject);
    procedure ckOverflowClick(Sender: TObject);
    procedure ckUnderflowClick(Sender: TObject);
    procedure ckInexactClick(Sender: TObject);
    procedure ckOperandClick(Sender: TObject);
    procedure Test2Click(Sender: TObject);
    procedure System1FPChange(Sender: TObject);
    procedure Test3Click(Sender: TObject);
    procedure Test5Click(Sender: TObject);
    procedure Test4Click(Sender: TObject);

    procedure HandleException(Sender :TObject; E :Exception);
    procedure MsgTestClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation
uses
    Win87Em;
{$R *.DFM}

   function UIFloatToStr(f :Extended):string;
   begin
        if IsNAN(f) then
           Result := 'NAN'
        else if f = INF then
           Result := 'INF'
        else
           Result := FloatToStr(f)
   end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
     Close
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
    {Application.OnException := HandleException;}
    with FloatingPointUnit1 do begin
       if BuggyPentiumFDIV then begin
          BugPresentLabel.Caption := 'IS PRESENT';
          BugPresentLabel.Font.Color := clRed;
       end;
       if not FPUAvailable then begin
          FPUPresentLabel.Caption := 'NOT PRESENT';
          FPUPresentLabel.Font.Color := clRed;
       end
    end;
    System1FPChange(Self);
end;

procedure TMainForm.System1FPChange(Sender: TObject);
begin
    with FloatingPointUnit1 do begin
       ckIgnore.Checked      := IgnoreExceptions;

       ckOperand.Checked     := f87InvalidOperand in ControlWord;
       ckByZero.Checked      := f87DivideByZero   in ControlWord;
       ckOverflow.Checked    := f87Overflow       in ControlWord;
       ckUnderflow.Checked   := f87Underflow      in ControlWord;
       ckInexact.Checked     := f87Inexact        in ControlWord;
    end
end;

procedure TMainForm.ckIgnoreClick(Sender: TObject);
begin
     FloatingPointUnit1.IgnoreExceptions := ckIgnore.Checked;
     CWPanel.Enabled := not ckIgnore.Checked;
     if not CWPanel.Enabled then
        CWPanel.Font.Color := clGray
     else
        CWPanel.Font.Color := clBlack
end;

procedure TMainForm.ckByZeroClick(Sender: TObject);
begin
     with FloatingPointUnit1 do
        if ckByZero.Checked then
            ControlWord := ControlWord + [f87DivideByZero]
        else
            ControlWord := ControlWord - [f87DivideByZero];
end;

procedure TMainForm.ckOverflowClick(Sender: TObject);
begin
     with FloatingPointUnit1 do
        if ckOverflow.Checked then
            ControlWord := ControlWord + [f87Overflow]
        else
            ControlWord := ControlWord - [f87Overflow];
end;

procedure TMainForm.ckUnderflowClick(Sender: TObject);
begin
     with FloatingPointUnit1 do
        if ckUnderflow.Checked then
            ControlWord := ControlWord + [f87Underflow]
        else
            ControlWord := ControlWord - [f87Underflow];
end;

procedure TMainForm.ckInexactClick(Sender: TObject);
begin
     with FloatingPointUnit1 do
        if ckInexact.Checked then
            ControlWord := ControlWord + [f87Inexact]
        else
            ControlWord := ControlWord - [f87Inexact];
end;

procedure TMainForm.ckOperandClick(Sender: TObject);
begin
     with FloatingPointUnit1 do
        if ckOperand.Checked then
            ControlWord := ControlWord + [f87InvalidOperand]
        else
            ControlWord := ControlWord - [f87InvalidOperand];
end;

procedure TMainForm.Test1Click(Sender: TObject);
var
   x :Single;
begin
     x := -1;
     Edit1.Text := UIFloatToStr(SQRT(x))
end;

procedure TMainForm.Test2Click(Sender: TObject);
var
   x :Single;
begin
     x := 0;
     Edit2.Text := UIFloatToStr(1.0/x);
end;

procedure TMainForm.Test3Click(Sender: TObject);
var
   x :Single;
   i :Integer;
begin
   x := 1e10;
   for i := 1 to 100 do
      x := x * x;
   Edit3.Text := UIFloatToStr(x)
end;

procedure TMainForm.Test5Click(Sender: TObject);
var
   x :Single;
begin
     x := 1e-20;
     Edit5.Text := UIFloatToStr(1e20+x)
end;

procedure TMainForm.Test4Click(Sender: TObject);
var
   x :Single;
begin
     x := 1e-60;
     x := x / 1e60;
     x := x / 1e60;
     Edit4.Text := UIFloatToStr(x)
end;

procedure TMainForm.HandleException(Sender :TObject; E :Exception);
begin
     if not (E is EAbort) then
        Application.ShowException(E);
     raise E;
end;

procedure TMainForm.MsgTestClick(Sender: TObject);
begin
     MessageDlg('A different kind of message!', mtWarning, mbAbortRetryIgnore, 0)
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
     { do this only to make some final points in the DLL example}
     FloatingPointUnit1.IgnoreExceptions := False 
end;

end.



